/*_############################################################################
  _## 
  _##  SNMP4J-AgentJMX - TypedCompositeDataAttribute.java  
  _## 
  _##  Copyright (C) 2006-2009  Frank Fock (SNMP4J.org)
  _##  
  _##  This program is free software; you can redistribute it and/or modify
  _##  it under the terms of the GNU General Public License version 2 as 
  _##  published by the Free Software Foundation.
  _##
  _##  This program is distributed in the hope that it will be useful,
  _##  but WITHOUT ANY WARRANTY; without even the implied warranty of
  _##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  _##  GNU General Public License for more details.
  _##
  _##  You should have received a copy of the GNU General Public License
  _##  along with this program; if not, write to the Free Software
  _##  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
  _##  MA  02110-1301  USA
  _##  
  _##########################################################################*/

package org.snmp4j.agent.mo.jmx.types;

import javax.management.openmbean.CompositeDataSupport;
import javax.management.*;

public class TypedCompositeDataAttribute extends TypedAttribute {

  private String compositeDataAttrName;
  private TypedAttribute proxyAttribute;

  public TypedCompositeDataAttribute(String beanName,
                                     String attrName,
                                     String type) throws ClassNotFoundException {
    super(beanName, type);
    this.compositeDataAttrName = attrName;
  }

  public TypedCompositeDataAttribute(String beanName,
                                     String attrName,
                                     Class type) {
    super(beanName, type);
    this.compositeDataAttrName = attrName;
  }

  public TypedCompositeDataAttribute(TypedAttribute proxyAttribute) {
    super(proxyAttribute.getName(), proxyAttribute.getType());
    this.compositeDataAttrName = proxyAttribute.getName();
    this.proxyAttribute = proxyAttribute;
  }

  public Object transformFromNative(Object nativeValue, ObjectName objectName) {
    if (nativeValue == null) {
      return null;
    }
    Object n = ((CompositeDataSupport)nativeValue).get(compositeDataAttrName);
    if (proxyAttribute != null) {
      n = proxyAttribute.transformFromNative(n, null);
    }
    return n;
  }

  public Object transformToNative(Object transformedValue,
                                  Object oldNativeValue, ObjectName objectName) {
    throw new UnsupportedOperationException();
  }
}
